#ifndef ESP8266_LED_FLASHER_H
#define ESP8266_LED_FLASHER_H
/**
   Wif_IR_Remote_ESP8266
   https://www.forward.com.au/pfod/HomeAutomation/Wifi_IR_Remote/index.html

   (c)2017 Forward Computing and Control Pty. Ltd.
   This code may be freely used for both private and commerical use.
   Provide this copyright is maintained.
*/

#include <Ticker.h>

// ESP2866_ledFlasher.ino
// this sketch is for inclusion with an ESP8266 Arduino project to  give a variety of led flash indications
enum ledFlasherTypeEnum {NO_LED_FLASH, SLOW_LED_FLASH, FAST_LED_FLASH, ALERT_LED_FLASH};
volatile ledFlasherTypeEnum ledFlashType = NO_LED_FLASH;
const float LED_FLASH_TIMER_INTERVAL = 0.1; // 0.1 sec
const int LED_FAST_FLASH_PERIOD = 2; // 0.2sec
const int LED_FAST_FLASH_OFF = 1; // 50% flash
const int LED_SLOW_FLASH_PERIOD = 18; // 1.8sec
const int LED_SLOW_FLASH_OFF = 9; // 50% flash
volatile int ledFlashCounter = 0;
volatile int ledFlashOff = 1;
volatile int ledFlashPeriod = 1;

Ticker ledFlasherTicker;
bool flasherLedOn = false;

int ledFlasher_ledpin = 0; // default GPIO0 for ESP8266
void setLedFlashType(ledFlasherTypeEnum f_type);
void turnFlasherLedOn();
void toggelFlasherLed();
void initLedFlasher();
void setLedFlashPin(int pin); // override default GPIO0

#endif // ESP8266_LED_FLASHER_H
