/**
   Wif_IR_Remote_ESP8266
   https://www.forward.com.au/pfod/HomeAutomation/Wifi_IR_Remote/index.html

   (c)2017 Forward Computing and Control Pty. Ltd.
   This code may be freely used for both private and commerical use.
   Provide this copyright is maintained.
*/

// ESP2866_ledFlasher.ino
// this sketch is for inclusion with an ESP8266 Arduino project to  give a variety of led flash indications
#include "ESP8266_ledFlasher.h"

void setLedFlashPin(int pin) {
  if (pin >= 0) {
    ledFlasher_ledpin = pin;
  }
  // else ignore
}

void handleFlash() {
  if (ledFlashType == NO_LED_FLASH) {
    turnFlasherLedOn(); // just turn led on
  } else if (ledFlashType == ALERT_LED_FLASH) {
    ledFlashCounter++;
    if (ledFlashCounter >= 24) {
      ledFlashCounter = 0; // reset
      turnFlasherLedOn();
      //           OFF                    ON                         OFF                        ON                        OFF                         0N                       OFF
    } else if ((ledFlashCounter == 4) || (ledFlashCounter == 6) || (ledFlashCounter == 14) || (ledFlashCounter == 15) || (ledFlashCounter == 16) || (ledFlashCounter == 17) || (ledFlashCounter == 18)) {
      toggelFlasherLed();
    }
  } else {
    // flash
    ledFlashCounter++;
    if (ledFlashCounter >= ledFlashPeriod) {
      ledFlashCounter = 0; // reset
      turnFlasherLedOn();
    } else if (ledFlashCounter == ledFlashOff) {
      toggelFlasherLed();
    }
  }
}

void turnFlasherLedOn() {
  flasherLedOn = true;
  digitalWrite(ledFlasher_ledpin, LOW); // low for ON on HUZZAH ESP8266
}

void toggelFlasherLed() {
  flasherLedOn = !flasherLedOn;
  if (flasherLedOn) {
    digitalWrite(ledFlasher_ledpin, LOW); // low for ON on HUZZAH ESP8266
  } else {
    digitalWrite(ledFlasher_ledpin, HIGH);
  }
}

void initLedFlasher() {
  pinMode(ledFlasher_ledpin, OUTPUT);
  setLedFlashType(NO_LED_FLASH); // turns led ON
  ledFlasherTicker.attach(LED_FLASH_TIMER_INTERVAL, handleFlash);
}
/**
         Set flash type
*/
void setLedFlashType(ledFlasherTypeEnum f_type) {
  if (f_type == NO_LED_FLASH)  {
    ledFlashType = f_type;
    turnFlasherLedOn();
    return;
  }
  if (f_type == ledFlashType) {
    return; // no chabnge
  }
  if (f_type == ALERT_LED_FLASH) {
    ledFlashType = f_type;
    turnFlasherLedOn();
    ledFlashCounter = 0;
  } else if (f_type > ledFlashType)  {
    turnFlasherLedOn();
    ledFlashCounter = 0;
    ledFlashType = f_type;
    switch (ledFlashType) {
      case FAST_LED_FLASH:
        ledFlashPeriod = LED_FAST_FLASH_PERIOD;
        ledFlashOff = LED_FAST_FLASH_OFF;
        break;
      case SLOW_LED_FLASH:
        ledFlashPeriod = LED_SLOW_FLASH_PERIOD;
        ledFlashOff = LED_SLOW_FLASH_OFF;
        break;
      default:
        break;
    }
  }
}


