#ifndef WIFI_WEB_CONFIG_H
#define WIFI_WEB_CONFIG_H
// WifiWebConfig.h
/**
   Wif_IR_Remote_ESP8266
   https://www.forward.com.au/pfod/HomeAutomation/Wifi_IR_Remote/index.html

   (c)2017 Forward Computing and Control Pty. Ltd.
   This code may be freely used for both private and commerical use.
   Provide this copyright is maintained.
*/

/*
  WiFiConfg is an addon version of An ESP8266 Cheap and Simple Wifi Shield for Arduino and other micros
  This file has been modified to fix the configured baud rate to 115200 to match IR_Remote_TeensyLC.ino

  To Config
  Short the config link and apply power
    and connect to the pfodWifiWebConfig access point
  using the password set in  #define pfodWifiWebConfigPASSWORD  (below)
  Scan this password from the QR code generated with http://www.forward.com.au/pfod/secureChallengeResponse/keyGenerator/index.html

  Once you connect to the Access Point open the webpage
  http://10.1.1.1 to setup your network parameters
  ssid, password and either DHCP or staticIP and portNo.
  Then when you reboot (with the config link removed) you can connect to the ip:portNo and pass data via the UART in both directions.

  The micro board that is connected to this module should have setup() code stating with

  void setup() {
   delay(1000);  // skip skip the ESP8266 debug output
   Serial.begin(19200); // or whatever baud rate you configured via the webpage

    .... rest of setup here
     ..


  see http://www.forward.com.au/pfod/pfodWifiConfig/ESP8266/pfodWifiConfig_ESP8266.html for details
  For an example QR code image look in the directory this file is in.
*/

/**
    Cheap and Simple Wifi Shield for Arduino and other micros
   http://www.forward.com.au/pfod/CheapWifiSheild/index.html

   (c)2015 Forward Computing and Control Pty. Ltd.
   This code may be freely used for both private and commerical use.
   Provide this copyright is maintained.
*/

#include <EEPROM.h>
#include <pfodESP8266Utils.h>
#include <ESP8266WebServer.h>
#include <ESP8266WiFi.h>
#include <pfodESP8266BufferedClient.h>

//---------- Arduino 1.6.6+ needs these declarations -------------
void handleNotFound();
void handleRoot();
void handleConfig();
void setupAP(const char* ssid_wifi, const char* password_wifi);

bool networkConnected = false; // set to true when connect to network

WiFiServer server(80);
WiFiClient client; // just one client reused
pfodESP8266BufferedClient bufferedClient;
uint32_t getConnectionTimeout(); // get configured connection timeout
#endif //WIFI_WEB_CONFIG_H
